#include <iostream>
#include <iomanip>
#include <fstream>
#include <vector>
#include <array>
#include <algorithm>
#include <utility>
#include <map>
#include <queue>
#include <set>
#include <cmath>
#include <cstdio>
#include <cstring>
#include <functional>
#include <numeric>
#include <list>
#include <ios>
#include <bitset>
#include <string>
#include <sstream>

constexpr int maxK = 5000;
typedef std::bitset<maxK+1> bs;

void solve(int n, int k, const std::string &s)
{
    std::vector<std::vector<bs> > dp(n+1);
    for (int i = 0; i <= n; i++)
        dp[i].resize((n + 1) * (n + 1));
    for (int i = 0; i <= n; i++)
        dp[n][i * (n + 1) + 0].set(k);
    for (int pos = n-1; pos >= 0; --pos)
    {
        char c = s[pos];
        if (c == 'C')
        {
            for (int i = 0; i <= n; i++)
            {
                for (int j = 0; j < n; j++)
                {
                    dp[pos][i * (n + 1) + j + 1] = dp[pos + 1][i * (n + 1) + j];
                }
            }
        }
        else if (c == 'N')
        {
            for (int i = 0; i < n; i++)
            {
                for (int j = 0; j <= n; j++)
                {
                    dp[pos][i * (n + 1) + j] = dp[pos + 1][(i + 1) * (n + 1) + j];
                }
            }
        }
        else if (c == 'A')
        {
            for (int i = 0; i <= n; i++)
            {
                for (int j = 0; j <= n; j++)
                {
                    dp[pos][i * (n + 1) + j] = dp[pos + 1][i * (n + 1) + j] >> i * j;                
                }
            }
        }
        else if (c == '?')
        {
            for (int i = 0; i <= n; i++)
            {
                for (int j = 0; j <= n; j++)
                {
                    dp[pos][i * (n + 1) + j] |= dp[pos + 1][i * (n + 1) + j];
                    dp[pos][i * (n + 1) + j] |= (dp[pos + 1][i * (n + 1) + j] >> i * j);
                    if (i != n)
                    {
                        dp[pos][i * (n + 1) + j] |= dp[pos + 1][(i + 1) * (n + 1) + j];
                    }
                    if (j != n)
                    {
                        dp[pos][i * (n + 1) + j + 1] |= dp[pos + 1][i * (n + 1) + j];
                    }
                }
            }
        }
        else
        {
            for (int i = 0; i <= n; i++)
            {
                for (int j = 0; j <= n; j++)
                {
                    dp[pos][i * (n + 1) + j] = dp[pos + 1][i * (n + 1) + j];
                }
            }
        }
    }
    int curk = 0;
    int curCs = -1;
    int curNs = 0;
    for (int i = 0; i <= n; i++)
    {
        if (dp[0][0 * (n + 1) + i].test(curk))
        {
            curCs = i;
            break;
        }
    }
    if (curCs == -1)
    {
        std::cout << "-1" << std::endl;
        return;
    }
    for (int pos = 0; pos < n; pos++)
    {
        char c = s[pos];
        if (c == 'C')
        {
            std::cout << c;
            curCs--;
        }
        else if (c == 'N')
        {
            std::cout << c;
            curNs++;
        }
        else if (c == 'A')
        {
            std::cout << c;
            curk += curNs * curCs;
        }
        else if (c == '?')
        {
            if (dp[pos + 1][curNs * (n + 1) + curCs].test(curk))
            {
                std::cout << 'B';
            }
            else if (curNs < n && dp[pos + 1][(curNs + 1) * (n + 1) + curCs].test(curk))
            {
                std::cout << 'N';
                curNs++;
            }
            else if (curCs > 0 && dp[pos + 1][curNs * (n + 1) + curCs - 1].test(curk))
            {
                std::cout << 'C';
                curCs--;
            }
            else
            {
                std::cout << 'A';
                curk += curNs * curCs;
            }
        }
        else
        {
            std::cout << c;
        }
    }
    std::cout << std::endl;
}

int main()
{
    int n, k;
    std::string s;
    std::cin >> n >> k >> s;
    solve(n, k, s);
    /*int n = 50;
    std::string s;
    for (int i = 0; i < n; i++)
        s += '?';
    for (int k = 0; k <= 5000; k++)
    {
        std::cout << k << ": ";
        solve(n, k, s);
    }*/
}
